JUCE: AudioIODevice Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
AudioIODevice Class Referenceabstract
juce_audio_devices » audio_io

Base class for an audio device with synchronised input and output channels. More...

`#include <juce_AudioIODevice.h>`

## Public Member Functions
virtual | ~AudioIODevice ()
| Destructor.
const String & | getName () const noexcept
| Returns the device's name, (as set in the constructor).
const String & | getTypeName () const noexcept
| Returns the type of the device.
virtual StringArray | getOutputChannelNames ()=0
| Returns the names of all the available output channels on this device.
virtual StringArray | getInputChannelNames ()=0
| Returns the names of all the available input channels on this device.
virtual std::optional< BigInteger > | getDefaultOutputChannels () const
| For devices that support a default layout, returns the channels that are enabled in the default layout.
virtual std::optional< BigInteger > | getDefaultInputChannels () const
| For devices that support a default layout, returns the channels that are enabled in the default layout.
virtual Array< double > | getAvailableSampleRates ()=0
| Returns the set of sample-rates this device supports.
virtual Array< int > | getAvailableBufferSizes ()=0
| Returns the set of buffer sizes that are available.
virtual int | getDefaultBufferSize ()=0
| Returns the default buffer-size to use.
virtual String | open (const BigInteger &inputChannels, const BigInteger &outputChannels, double sampleRate, int bufferSizeSamples)=0
| Tries to open the device ready to play.
virtual void | close ()=0
| Closes and releases the device if it's open.
virtual bool | isOpen ()=0
| Returns true if the device is still open.
virtual void | start (AudioIODeviceCallback *callback)=0
| Starts the device actually playing.
virtual void | stop ()=0
| Stops the device playing.
virtual bool | isPlaying ()=0
| Returns true if the device is still calling back.
virtual String | getLastError ()=0
| Returns the last error that happened if anything went wrong.
virtual int | getCurrentBufferSizeSamples ()=0
| Returns the buffer size that the device is currently using.
virtual double | getCurrentSampleRate ()=0
| Returns the sample rate that the device is currently using.
virtual int | getCurrentBitDepth ()=0
| Returns the device's current physical bit-depth.
virtual BigInteger | getActiveOutputChannels () const =0
| Returns a mask showing which of the available output channels are currently enabled.
virtual BigInteger | getActiveInputChannels () const =0
| Returns a mask showing which of the available input channels are currently enabled.
virtual int | getOutputLatencyInSamples ()=0
| Returns the device's output latency.
virtual int | getInputLatencyInSamples ()=0
| Returns the device's input latency.
virtual AudioWorkgroup | getWorkgroup () const
| Returns the workgroup for this device.
virtual bool | hasControlPanel () const
| True if this device can show a pop-up control panel for editing its settings.
virtual bool | showControlPanel ()
| Shows a device-specific control panel if there is one.
virtual bool | setAudioPreprocessingEnabled (bool shouldBeEnabled)
| On devices which support it, this allows automatic gain control or other mic processing to be disabled.
virtual int | getXRunCount () const noexcept
| Returns the number of under- or over runs reported by the OS since playback/recording has started.

## Protected Member Functions
| AudioIODevice (const String &deviceName, const String &typeName)
| Creates a device, setting its name and type member variables.

## Protected Attributes
String | name
String | typeName

## Detailed Description

Base class for an audio device with synchronised input and output channels.

Subclasses of this are used to implement different protocols such as DirectSound, ASIO, CoreAudio, etc.

To create one of these, you'll need to use the AudioIODeviceType class - see the documentation for that class for more info.

For an easier way of managing audio devices and their settings, have a look at the AudioDeviceManager class.

See also
  AudioIODeviceType, AudioDeviceManager

## Constructor & Destructor Documentation

## ◆ ~AudioIODevice()

virtual AudioIODevice::~AudioIODevice | ( |  | ) |
| virtual

Destructor.

## ◆ AudioIODevice()

AudioIODevice::AudioIODevice | ( | const String & | deviceName,
|  | const String & | typeName
| ) |  |
| protected

Creates a device, setting its name and type member variables.

## Member Function Documentation

## ◆ getName()

const String & AudioIODevice::getName | ( |  | ) | const
| noexcept

Returns the device's name, (as set in the constructor).

References name.

## ◆ getTypeName()

const String & AudioIODevice::getTypeName | ( |  | ) | const
| noexcept

Returns the type of the device.

E.g. "CoreAudio", "ASIO", etc. - this comes from the AudioIODeviceType that created it.

## ◆ getOutputChannelNames()

virtual StringArray AudioIODevice::getOutputChannelNames | ( |  | ) |
| pure virtual

Returns the names of all the available output channels on this device.

To find out which of these are currently in use, call getActiveOutputChannels().

## ◆ getInputChannelNames()

virtual StringArray AudioIODevice::getInputChannelNames | ( |  | ) |
| pure virtual

Returns the names of all the available input channels on this device.

To find out which of these are currently in use, call getActiveInputChannels().

## ◆ getDefaultOutputChannels()

virtual std::optional< BigInteger > AudioIODevice::getDefaultOutputChannels | ( |  | ) | const
| virtual

For devices that support a default layout, returns the channels that are enabled in the default layout.

Returns nullopt if the device doesn't supply a default layout.

## ◆ getDefaultInputChannels()

virtual std::optional< BigInteger > AudioIODevice::getDefaultInputChannels | ( |  | ) | const
| virtual

For devices that support a default layout, returns the channels that are enabled in the default layout.

Returns nullopt if the device doesn't supply a default layout.

## ◆ getAvailableSampleRates()

virtual Array< double > AudioIODevice::getAvailableSampleRates | ( |  | ) |
| pure virtual

Returns the set of sample-rates this device supports.

See also
  getCurrentSampleRate

## ◆ getAvailableBufferSizes()

virtual Array< int > AudioIODevice::getAvailableBufferSizes | ( |  | ) |
| pure virtual

Returns the set of buffer sizes that are available.

See also
  getCurrentBufferSizeSamples, getDefaultBufferSize

## ◆ getDefaultBufferSize()

virtual int AudioIODevice::getDefaultBufferSize | ( |  | ) |
| pure virtual

Returns the default buffer-size to use.

Returns
  a number of samples

See also
  getAvailableBufferSizes

## ◆ open()

virtual String AudioIODevice::open | ( | const BigInteger & | inputChannels,
|  | const BigInteger & | outputChannels,
|  | double | sampleRate,
|  | int | bufferSizeSamples
| ) |  |
| pure virtual

Tries to open the device ready to play.

Parameters

  inputChannels | a BigInteger in which a set bit indicates that the corresponding input channel should be enabled
  outputChannels | a BigInteger in which a set bit indicates that the corresponding output channel should be enabled
  sampleRate | the sample rate to try to use - to find out which rates are available, see getAvailableSampleRates()
  bufferSizeSamples | the size of i/o buffer to use - to find out the available buffer sizes, see getAvailableBufferSizes()

Returns
  an error description if there's a problem, or an empty string if it succeeds in opening the device

See also
  close

## ◆ close()

virtual void AudioIODevice::close | ( |  | ) |
| pure virtual

Closes and releases the device if it's open.

## ◆ isOpen()

virtual bool AudioIODevice::isOpen | ( |  | ) |
| pure virtual

Returns true if the device is still open.

A device might spontaneously close itself if something goes wrong, so this checks if it's still open.

## ◆ start()

virtual void AudioIODevice::start | ( | AudioIODeviceCallback * | callback | ) |
| pure virtual

Starts the device actually playing.

This must be called after the device has been opened.

Parameters

  callback | the callback to use for streaming the data.

See also
  AudioIODeviceCallback, open

## ◆ stop()

virtual void AudioIODevice::stop | ( |  | ) |
| pure virtual

Stops the device playing.

Once a device has been started, this will stop it. Any pending calls to the callback class will be flushed before this method returns.

## ◆ isPlaying()

virtual bool AudioIODevice::isPlaying | ( |  | ) |
| pure virtual

Returns true if the device is still calling back.

The device might mysteriously stop, so this checks whether it's still playing.

## ◆ getLastError()

virtual String AudioIODevice::getLastError | ( |  | ) |
| pure virtual

Returns the last error that happened if anything went wrong.

## ◆ getCurrentBufferSizeSamples()

virtual int AudioIODevice::getCurrentBufferSizeSamples | ( |  | ) |
| pure virtual

Returns the buffer size that the device is currently using.

If the device isn't actually open, this value doesn't really mean much.

## ◆ getCurrentSampleRate()

virtual double AudioIODevice::getCurrentSampleRate | ( |  | ) |
| pure virtual

Returns the sample rate that the device is currently using.

If the device isn't actually open, this value doesn't really mean much.

## ◆ getCurrentBitDepth()

virtual int AudioIODevice::getCurrentBitDepth | ( |  | ) |
| pure virtual

Returns the device's current physical bit-depth.

If the device isn't actually open, this value doesn't really mean much.

## ◆ getActiveOutputChannels()

virtual BigInteger AudioIODevice::getActiveOutputChannels | ( |  | ) | const
| pure virtual

Returns a mask showing which of the available output channels are currently enabled.

See also
  getOutputChannelNames

## ◆ getActiveInputChannels()

virtual BigInteger AudioIODevice::getActiveInputChannels | ( |  | ) | const
| pure virtual

Returns a mask showing which of the available input channels are currently enabled.

See also
  getInputChannelNames

## ◆ getOutputLatencyInSamples()

virtual int AudioIODevice::getOutputLatencyInSamples | ( |  | ) |
| pure virtual

Returns the device's output latency.

This is the delay in samples between a callback getting a block of data, and that data actually getting played.

## ◆ getInputLatencyInSamples()

virtual int AudioIODevice::getInputLatencyInSamples | ( |  | ) |
| pure virtual

Returns the device's input latency.

This is the delay in samples between some audio actually arriving at the soundcard, and the callback getting passed this block of data.

## ◆ getWorkgroup()

virtual AudioWorkgroup AudioIODevice::getWorkgroup | ( |  | ) | const
| virtual

Returns the workgroup for this device.

## ◆ hasControlPanel()

virtual bool AudioIODevice::hasControlPanel | ( |  | ) | const
| virtual

True if this device can show a pop-up control panel for editing its settings.

This is generally just true of ASIO devices. If true, you can call showControlPanel() to display it.

## ◆ showControlPanel()

virtual bool AudioIODevice::showControlPanel | ( |  | ) |
| virtual

Shows a device-specific control panel if there is one.

This should only be called for devices which return true from hasControlPanel().

## ◆ setAudioPreprocessingEnabled()

virtual bool AudioIODevice::setAudioPreprocessingEnabled | ( | bool | shouldBeEnabled | ) |
| virtual

On devices which support it, this allows automatic gain control or other mic processing to be disabled.

If the device doesn't support this operation, it'll return false.

## ◆ getXRunCount()

virtual int AudioIODevice::getXRunCount | ( |  | ) | const
| virtualnoexcept

Returns the number of under- or over runs reported by the OS since playback/recording has started.

This number may be different than determining the Xrun count manually (by measuring the time spent in the audio callback) as the OS may be doing some buffering internally - especially on mobile devices.

Returns -1 if playback/recording has not started yet or if getting the underrun count is not supported for this device (Android SDK 23 and lower).

## Member Data Documentation

## ◆ name

String AudioIODevice::name
| protected

## ◆ typeName

String AudioIODevice::typeName
| protected

The documentation for this class was generated from the following file:

- juce_AudioIODevice.h